=== debian/changelog ===
pico-sdk (2.2.0-1) unstable; urgency=medium

  * add debian/README.source
  * New upstream version 2.2.0
     - fix pioasm build failure caused by GCC 15 changes (closes: #1097583)

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Sat, 06 Sep 2025 17:59:05 +0200
